//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGPixelShader.cpp
// Description : Classe permettant de stocker les informations necessaires
//               a un Pixel Shader ecrit en CG.
//===========================================================================


#include "./CGPixelShader.h"


//-------------------------------------------------------------------------
// CONSTRUCTEURS - DESTRUCTEUR --------------------------------------------
//-------------------------------------------------------------------------

CCGPixelShader::CCGPixelShader(       CGcontext    context      ,
                                const char      *  file         ,
                                const char      *  entry        ,
                                      CGenum       type         ,
                                      CGprofile    profile      ,
                                const char      ** compiler_args )
{
   // on recupere le meilleur profil si demande
   m_cgpProfile = profile == 0 ? cgGLGetLatestProfile( CG_GL_FRAGMENT ) : profile ;

   // on met les meilleures options si demandees
   if( compiler_args == 0 ) { cgGLSetOptimalOptions( m_cgpProfile ) ; }

   // on cree le programme
   m_cgpProgram = cgCreateProgramFromFile( context, type, file, m_cgpProfile, entry, compiler_args ) ;

   // on le charge
   cgGLLoadProgram( m_cgpProgram ) ;
}

//-------------------------------------------------------------------------
