//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGShader.h
// Description : Classe permettant de stocker les informations necessaires
//               a un Shader ecrit en CG.
//===========================================================================


#ifndef __CGSHADER_H
#define __CGSHADER_H

#include <Cg/cg.h>
#include <Cg/cgGL.h>


//-------------------------------------------------------------------------
class CCGShader
{

public :
   
   //----------------------------------------------------------------
   CCGShader(       CGcontext    context                     ,
              const char      *  file                        ,
              const char      *  entry         = 0           ,
                    CGenum       type          = CG_SOURCE   ,
                    CGprofile    profile       = (CGprofile)0,    // 0 == meilleur
              const char      ** compiler_args = 0            ) ; // 0 == meilleur

   virtual ~CCGShader( void ) ;
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // ACCESSEURS
   virtual CGprogram getProgram( void ) const { return m_cgpProgram ; }
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // INTERFACE UTILISATION
   virtual void enable(  void ) ;
   virtual void disable( void ) ;
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // MODIFIEURS
   virtual void recompile( void ) ;
   //----------------------------------------------------------------

protected :

   // constructeur par defaut pour les classes filles
   CCGShader( void ) {}

   CGprogram m_cgpProgram ;
   CGprofile m_cgpProfile ;

} ;
//-------------------------------------------------------------------------

#endif //__CGSHADER_H
