//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGToondeplPS.h
// Description : Classe pour le Pixel Shader de Toon Shading
//===========================================================================


#include "./CGToondeplPS.h"


//-------------------------------------------------------------------------
// INTERFACE UTILISATION --------------------------------------------------
//-------------------------------------------------------------------------

void CCGToondeplPS::enable( void )
{
   CCGPixelShader::enable() ;

   cgGLEnableTextureParameter( m_cgpTraitTex   ) ;

   cgGLBindProgram( m_cgpProgram ) ;
}

//-------------------------------------------------------------------------

void CCGToondeplPS::disable( void )
{
   cgGLDisableTextureParameter( m_cgpTraitTex ) ;

   CCGPixelShader::disable() ;
}




//-------------------------------------------------------------------------
// PARAMETRAGE DU SHADER --------------------------------------------------
//-------------------------------------------------------------------------

void CCGToondeplPS::setTraitTexParamName( const char * name )
{
   m_cgpTraitTex = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGToondeplPS::setCU_TraitTex( GLuint texname )
{
   cgGLSetTextureParameter( m_cgpTraitTex, texname ) ;
}

//-------------------------------------------------------------------------
