//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGToondeplVS.h
// Description : Classe pour le Vertex Shader de génération des traits.
//               
//===========================================================================


#include "./CGToondeplVS.h"
#include <stdio.h>


//-------------------------------------------------------------------------
// INTERFACE UTILISATION --------------------------------------------------
//-------------------------------------------------------------------------

void CCGToondeplVS::enable(  void )
{
   CCGVertexShader::enable() ;
   
   cgGLSetParameter3fv( m_cgpEyePosition, m_pEyePosition->position() ) ;

   cgGLSetStateMatrixParameter( m_cgpModelViewProjMatrix, CG_GL_MODELVIEW_PROJECTION_MATRIX, CG_GL_MATRIX_IDENTITY ) ;
  

   cgGLBindProgram( m_cgpProgram ) ;
}

//-------------------------------------------------------------------------

void CCGToondeplVS::disable( void )
{
   cgGLDisableClientState( m_cgpModelViewProjMatrix ) ;

   CCGVertexShader::disable() ;
}




//-------------------------------------------------------------------------
// PARAMETRAGE DU SHADER --------------------------------------------------
//-------------------------------------------------------------------------

void CCGToondeplVS::setModelViewProjMatrixParamName( const char * name )
{
   m_cgpModelViewProjMatrix = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGToondeplVS::setEyePositionParamName( const char * name )
{
   m_cgpEyePosition = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGToondeplVS::setSeuilTraitParamName( const char * name )
{
   m_cgpSeuilTrait = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGToondeplVS::setLongCaracParamName( const char * name )
{
   m_cgpLongCarac = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGToondeplVS::setVitesseParamName( const char * name )
{
   m_cgpVitesse = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGToondeplVS::setCU_SeuilTrait( const float val )
{
   m_pSeuilTrait = val ;
   cgGLSetParameter1f( m_cgpSeuilTrait, val ) ;
}

//-------------------------------------------------------------------------

void CCGToondeplVS::setCU_LongCarac( const float val )
{
   m_pLongCarac = val ;
   cgGLSetParameter1f( m_cgpLongCarac, val ) ;
}

//-------------------------------------------------------------------------

void CCGToondeplVS::setCU_Vitesse( float V[3] )
{
   m_pVitesse[0] = V[0];
   m_pVitesse[1] = V[1];
   m_pVitesse[2] = V[2];
   cgGLSetParameter3fv( m_cgpVitesse, m_pVitesse ) ;
}

//-------------------------------------------------------------------------

void CCGToondeplVS::setU_EyePosition( const qglviewer::Camera * cam )
{
   m_pEyePosition = cam ;
   cgGLSetParameter3fv( m_cgpEyePosition, cam->position() ) ;
}

//-------------------------------------------------------------------------

