//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGToondeplVS.h
// Description : Classe pour le Vertex Shader de génération des traits.
//               
//===========================================================================


#ifndef __CGTOONDEPLVS_H
#define __CGTOONDEPLVS_H

#include <QGLViewer/qglviewer.h>
#include "./CGVertexShader.h"


//-------------------------------------------------------------------------
class CCGToondeplVS : public CCGVertexShader
{

public :

   //----------------------------------------------------------------
   // CONSTRUCTEURS - DESTRUCTEURS
   CCGToondeplVS( CGcontext context, const char * file, const char * entry )
      : CCGVertexShader( context, file, entry ) {}
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // INTERFACE UTILISATION
   void enable ( void ) ;
   void disable( void ) ;
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // PARAMETRAGE DU SHADER
   void setSeuilTraitParamName         ( const char * name ) ;
   void setModelViewProjMatrixParamName( const char * name ) ;
   void setEyePositionParamName        ( const char * name ) ;
   void setVitesseParamName            ( const char * name ) ;
   void setLongCaracParamName          ( const char * name ) ;
   

   // parametres uniformes constants
   void setCU_SeuilTrait( const float val ) ;
   void setCU_LongCarac ( const float val );
   void setCU_Vitesse   ( float V[3] ) ;

   // parametres uniformes
   void setU_EyePosition( const qglviewer::Camera * cam ) ;
   
   //----------------------------------------------------------------

private :

   CGparameter m_cgpModelViewProjMatrix ;
   CGparameter m_cgpEyePosition         ;

   CGparameter m_cgpSeuilTrait          ;
   CGparameter m_cgpLongCarac           ;
   CGparameter m_cgpVitesse             ;
   
   float m_pSeuilTrait   ;
   float m_pLongCarac    ;
   float m_pVitesse[3]   ;
   const qglviewer::Camera * m_pEyePosition ;

} ;
//-------------------------------------------------------------------------

#endif //__CGToondeplVSVS_H
