//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGToonimPS.h
// Description : Classe pour le Pixel Shader de l'effet des bords en
//               Toon Shading.
//===========================================================================


#include "./CGToonimPS.h"


//-------------------------------------------------------------------------
// INTERFACE UTILISATION --------------------------------------------------
//-------------------------------------------------------------------------

void CCGToonimPS::enable( void )
{
   CCGPixelShader::enable() ;

   cgGLEnableTextureParameter( m_cgpEdgeTex    ) ;
   cgGLEnableTextureParameter( m_cgpDiffuseTex ) ;

   cgGLBindProgram( m_cgpProgram ) ;
}

//-------------------------------------------------------------------------

void CCGToonimPS::disable( void )
{
   cgGLDisableTextureParameter( m_cgpDiffuseTex ) ;
   cgGLDisableTextureParameter( m_cgpEdgeTex    ) ;

   CCGPixelShader::disable() ;
}




//-------------------------------------------------------------------------
// PARAMETRAGE DU SHADER --------------------------------------------------
//-------------------------------------------------------------------------

void CCGToonimPS::setEdgeTexParamName( const char * name )
{
   m_cgpEdgeTex = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGToonimPS::setDiffuseTexParamName( const char * name )
{
   m_cgpDiffuseTex = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGToonimPS::setSeuilParamName( const char * name )
{
   m_cgpSeuil = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGToonimPS::setCouleur1ParamName( const char * name )
{
   m_cgpCouleur1 = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGToonimPS::setCouleur2ParamName( const char * name )
{
   m_cgpCouleur2 = cgGetNamedParameter( m_cgpProgram, name ) ;
}


//-------------------------------------------------------------------------

void CCGToonimPS::setCU_EdgeTex( GLuint texname )
{
   cgGLSetTextureParameter( m_cgpEdgeTex, texname ) ;
}

//-------------------------------------------------------------------------

void CCGToonimPS::setCU_DiffuseTex( GLuint texname )
{
   cgGLSetTextureParameter( m_cgpDiffuseTex, texname ) ;
}

//-------------------------------------------------------------------------

void CCGToonimPS::setCU_Seuil( float val )
{
   m_pSeuil = val;
   cgGLSetParameter1f( m_cgpSeuil, val);
}

//-------------------------------------------------------------------------

void CCGToonimPS::setCU_Couleur1( float V[3] )
{
   m_pCouleur1[0] = V[0];
   m_pCouleur1[1] = V[1];
   m_pCouleur1[2] = V[2];
   cgGLSetParameter3fv( m_cgpCouleur1, m_pCouleur1 );
}

//-------------------------------------------------------------------------

void CCGToonimPS::setCU_Couleur2( float V[3] )
{
   m_pCouleur2[0] = V[0];
   m_pCouleur2[1] = V[1];
   m_pCouleur2[2] = V[2];
   cgGLSetParameter3fv( m_cgpCouleur2, m_pCouleur2 );
}

//-------------------------------------------------------------------------
