//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGToonimPS.h
// Description : Classe pour le Pixel Shader de Toon Shading
//
//===========================================================================


#ifndef __CGTOONIMPS_H
#define __CGTOONIMPS_H

#include "./CGPixelShader.h"


//-------------------------------------------------------------------------
class CCGToonimPS : public CCGPixelShader
{

public :

   //----------------------------------------------------------------
   // CONSTRUCTEURS - DESTRUCTEURS
   CCGToonimPS( CGcontext context, const char * file, const char * entry )
      : CCGPixelShader( context, file, entry ) {}
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // INTERFACE UTILISATION
   void enable(  void ) ;
   void disable( void ) ;
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // PARAMETRAGE DU SHADER
   void setEdgeTexParamName   ( const char * name ) ;
   void setDiffuseTexParamName( const char * name ) ;
   void setSeuilParamName     ( const char * name ) ;
   void setCouleur1ParamName  ( const char * name ) ;
   void setCouleur2ParamName  ( const char * name ) ;

   // parametres uniformes constants
   void setCU_EdgeTex   ( GLuint texname ) ;
   void setCU_DiffuseTex( GLuint texname ) ;
   void setCU_Seuil     ( float val  ) ;
   void setCU_Couleur1  ( float V[3] ) ;
   void setCU_Couleur2  ( float V[3] ) ;
   
   //----------------------------------------------------------------

private :


   CGparameter m_cgpSeuil      ;
   CGparameter m_cgpCouleur1   ;
   CGparameter m_cgpCouleur2   ;
   CGparameter m_cgpEdgeTex    ;
   CGparameter m_cgpDiffuseTex ;
   
   float m_pSeuil       ;
   float m_pCouleur1[3] ;
   float m_pCouleur2[3] ;  


} ;
//-------------------------------------------------------------------------

#endif //__CGTOONIMPS_H
