//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGToonimVS.h
// Description : Classe pour le Vertex Shader de Toon Shading.
//               
//===========================================================================


#include "./CGToonimVS.h"
#include <stdio.h>


//-------------------------------------------------------------------------
// INTERFACE UTILISATION --------------------------------------------------
//-------------------------------------------------------------------------

void CCGToonimVS::enable(  void )
{
   CCGVertexShader::enable() ;
   
   cgGLSetParameter3fv( m_cgpEyePosition, m_pEyePosition->position() ) ;

   cgGLSetStateMatrixParameter( m_cgpModelViewProjMatrix, CG_GL_MODELVIEW_PROJECTION_MATRIX, CG_GL_MATRIX_IDENTITY ) ;
  

   cgGLBindProgram( m_cgpProgram ) ;
}

//-------------------------------------------------------------------------

void CCGToonimVS::disable( void )
{
   cgGLDisableClientState( m_cgpModelViewProjMatrix ) ;

   CCGVertexShader::disable() ;
}




//-------------------------------------------------------------------------
// PARAMETRAGE DU SHADER --------------------------------------------------
//-------------------------------------------------------------------------

void CCGToonimVS::setModelViewProjMatrixParamName( const char * name )
{
   m_cgpModelViewProjMatrix = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGToonimVS::setEyePositionParamName( const char * name )
{
   m_cgpEyePosition = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGToonimVS::setDeplParamName( const char * name )
{
   m_cgpDepl = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGToonimVS::setPuissance1ParamName( const char * name )
{
   m_cgpPuissance1 = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGToonimVS::setPuissance2ParamName( const char * name )
{
   m_cgpPuissance2 = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGToonimVS::setLight1PosParamName( const char * name )
{
   m_cgpLight1Pos = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGToonimVS::setLight1DirParamName( const char * name )
{
   m_cgpLight1Dir = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGToonimVS::setLight2PosParamName( const char * name )
{
   m_cgpLight2Pos = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGToonimVS::setLight2DirParamName( const char * name )
{
   m_cgpLight2Dir = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGToonimVS::setCU_Depl( const float val )
{
   m_pDepl = val ;
   cgGLSetParameter1f( m_cgpDepl, val ) ;
}

//-------------------------------------------------------------------------

void CCGToonimVS::setCU_Puissance1( const float val )
{
   m_pPuissance1 = val ;
   cgGLSetParameter1f( m_cgpPuissance1, val ) ;
}

//-------------------------------------------------------------------------

void CCGToonimVS::setCU_Puissance2( const float val )
{
   m_pPuissance2 = val ;
   cgGLSetParameter1f( m_cgpPuissance2, val ) ;
}

//-------------------------------------------------------------------------

void CCGToonimVS::setCU_Light1Pos( float V[3] )
{
   m_pLight1Pos[0] = V[0];
   m_pLight1Pos[1] = V[1];
   m_pLight1Pos[2] = V[2];
   cgGLSetParameter3fv( m_cgpLight1Pos, m_pLight1Pos ) ;
}

//-------------------------------------------------------------------------

void CCGToonimVS::setCU_Light1Dir( float V[3] )
{
   m_pLight1Dir[0] = V[0];
   m_pLight1Dir[1] = V[1];
   m_pLight1Dir[2] = V[2];
   cgGLSetParameter3fv( m_cgpLight1Dir, m_pLight1Dir ) ;
}

//-------------------------------------------------------------------------

void CCGToonimVS::setCU_Light2Pos( float V[3] )
{
   m_pLight2Pos[0] = V[0];
   m_pLight2Pos[1] = V[1];
   m_pLight2Pos[2] = V[2];
   cgGLSetParameter3fv( m_cgpLight2Pos, m_pLight2Pos ) ;
}

//-------------------------------------------------------------------------

void CCGToonimVS::setCU_Light2Dir( float V[3] )
{
   m_pLight2Dir[0] = V[0];
   m_pLight2Dir[1] = V[1];
   m_pLight2Dir[2] = V[2];
   cgGLSetParameter3fv( m_cgpLight2Dir, m_pLight2Dir ) ;
}

//-------------------------------------------------------------------------

void CCGToonimVS::setU_EyePosition( const qglviewer::Camera * cam )
{
   m_pEyePosition = cam ;
   cgGLSetParameter3fv( m_cgpEyePosition, cam->position() ) ;
}

//-------------------------------------------------------------------------

