//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGVertexShader.cpp
// Description : Classe permettant de stocker les informations necessaires
//               a un Vertex Shader ecrit en CG.
//===========================================================================


#include <stdio.h>
#include "./CGVertexShader.h"


//-------------------------------------------------------------------------
// CONSTRUCTEURS - DESTRUCTEUR --------------------------------------------
//-------------------------------------------------------------------------

CCGVertexShader::CCGVertexShader(       CGcontext    context      ,
                                  const char      *  file         ,
                                  const char      *  entry        ,
                                        CGenum       type         ,
                                        CGprofile    profile      ,
                                  const char      ** compiler_args )
{
   // on recupere le meilleur profil si demande
   m_cgpProfile = profile == 0 ? cgGLGetLatestProfile( CG_GL_VERTEX ) : profile ;

   // on met les meilleures options si demandees
   if( compiler_args == 0 ) { cgGLSetOptimalOptions( m_cgpProfile ) ; }

   // on cree le programme
   m_cgpProgram = cgCreateProgramFromFile( context, type, file, m_cgpProfile, entry, compiler_args ) ;

   if( m_cgpProgram == 0 ) { printf( "Programme non cree !!\n" ) ; }

   // on le charge
   cgGLLoadProgram( m_cgpProgram ) ;
}

//-------------------------------------------------------------------------
