//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : GLLight.h
// Description : Classe representant une source de lumière
//===========================================================================


#ifndef __GLLUMIERE_H
#define __GLLUMIERE_H


#include <GL/glut.h>

//---------------------------------------------------------------------------
class CGLLight
{

public :

   //----------------------------------------------------------------
   // CONSTRUCTEURS - DESTRUCTEURS
   // ajouter un pointeur sur fonction pour le cone
   CGLLight( const float Pos[3], const float Dir[3],
             const float Coul[3], const float Puiss,
             const float Angle, const float Echelle );
   
   CGLLight( void );
   //----------------------------------------------------------------
   
   //----------------------------------------------------------------
   // INTERFACE UTILISATION
   void draw      ( void ) ;
   void switch_on ( void ) ;
   void switch_off( void ) ;
   //----------------------------------------------------------------
   
   //----------------------------------------------------------------
   // PARAMETRAGE
   void Set_Position( const float Pos[3] );
   void Set_Direction( const float Dir[3] );
   void Set_Couleur( const float Coul[3] );
   void Set_Taille( const float Echelle );
   void Set_Puissance( const float Puiss );
   void Set_Angle_Cone( const float Angle );
   //----------------------------------------------------------------
 
   
   //----------------------------------------------------------------
   // ACCESSEURS
   void Get_Position( float Pos[3] );
   void Get_Direction( float Dir[3] );
   void Get_Couleur( float Coul[3] );
   float Get_Taille( void );
   float Get_Puissance( void );
   float Get_Angle_Cone( void );
   //----------------------------------------------------------------
   
   

private :
   
   float Position[3];
   float Direction[3];
   float Couleur[3];
   float LightViewMatrix[16];
   float Taille;
   float Puissance;
   float Angle_Cone;
   
   
   //----------------------------------------------------------------
   // FONCTIONS D'AFFICHAGE
   void drawPointe( void );
   void drawCylindre( void );
   void drawDisque( void );
   //----------------------------------------------------------------
   

} ;


#endif //__GLLUMIERE_H
