//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : GLTexture.cpp
// Description : Classe contenant les informations d'une texture OpenGL
//===========================================================================


#include <stdio.h>
#include <qgl.h>
#include "./GLTexture.h"


//-------------------------------------------------------------------------
// CONSTRUCTEURS - DESTRUCTEUR --------------------------------------------
//-------------------------------------------------------------------------

CGLTexture::CGLTexture( const char * filename )
{
   QImage temp( filename ) ;
   //m_pImage = temp ;
   m_pImage = QGLWidget::convertToGLFormat( temp ) ;
   
}





//-------------------------------------------------------------------------
// INTERFACE UTILISATION --------------------------------------------------
//-------------------------------------------------------------------------

GLuint CGLTexture::createGLTexture( GLenum wraps    ,
                                    GLenum wrapt    ,
                                    GLenum magfilter,
				    GLenum minfilter )
{
   glGenTextures( 1, &m_uiGLTexName ) ;
   if( m_pImage.height() == 1 )
   {
      glBindTexture( GL_TEXTURE_1D, m_uiGLTexName ) ;
      glTexParameteri( GL_TEXTURE_1D, GL_TEXTURE_WRAP_S, wraps ) ;
      glTexParameteri( GL_TEXTURE_1D, GL_TEXTURE_WRAP_T, wrapt ) ;
      glTexParameteri( GL_TEXTURE_1D, GL_TEXTURE_MAG_FILTER, magfilter ) ;
      glTexParameteri( GL_TEXTURE_1D, GL_TEXTURE_MIN_FILTER, minfilter ) ;
      
      // TODO : il faudrait faire attention au type de stockage dans la QImage
      glTexImage1D( GL_TEXTURE_1D, 0, GL_RGBA, m_pImage.width(), 0, GL_RGBA, GL_UNSIGNED_BYTE, m_pImage.bits() ) ;
   }
   else
   {
      glBindTexture( GL_TEXTURE_2D, m_uiGLTexName ) ;
      glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, wraps ) ;
      glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, wrapt ) ;
      glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, magfilter ) ;
      glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, minfilter ) ;

      // TODO : il faudrait faire attention au type de stockage dans la QImage
      glTexImage2D( GL_TEXTURE_2D, 0, GL_RGBA, m_pImage.width(), m_pImage.height(), 0, GL_RGBA, GL_UNSIGNED_BYTE, m_pImage.bits() ) ;
   }
}

//-------------------------------------------------------------------------
