//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : GLTexture.h
// Description : Classe contenant les informations d'une texture OpenGL
//===========================================================================


#ifndef __GLTEXTURE_H
#define __GLTEXTURE_H

#include <GL/gl.h>
#include <qimage.h>


//-------------------------------------------------------------------------
class CGLTexture
{
   
public :
      
   //-----------------------------------------------------------------
   // CONSTRUCTEURS - DESTRUCTEUR
   CGLTexture( const char * filename ) ;
   //-----------------------------------------------------------------

   //-----------------------------------------------------------------
   // ACCESSEURS
   GLuint getGLTexName( void ) const { return m_uiGLTexName ; }
   //-----------------------------------------------------------------

   //-----------------------------------------------------------------
   // INTERFACE UTILISATION
   GLuint createGLTexture( GLenum wraps     = GL_CLAMP  ,
                           GLenum wrapt     = GL_CLAMP  ,
                           GLenum magfilter = GL_NEAREST,
			   GLenum minfilter = GL_NEAREST ) ;
   //-----------------------------------------------------------------

protected :
      
   GLuint m_uiGLTexName ;
   QImage m_pImage      ;

} ;
//-------------------------------------------------------------------------

#endif //__GLTEXTURE_H
