//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGLWindow.cpp
// Description : Classe contenant les informations d'une fenetre
//===========================================================================


#include <GL/glut.h>
#include <stdio.h>
#include "./CGPass.h"
#include "./GLWindow.h"



//-------------------------------------------------------------------------
// ACTIONS ----------------------------------------------------------------
//-------------------------------------------------------------------------

void CGLWindow::draw( void )
{
   glClear( GL_DEPTH_BUFFER_BIT ) ;
   // Affichage des lumières
   for( int i = 0; i < nb_light; i++ ) {
      lampe[i]->draw();
   }

   for( CCGPass * pass = m_pEffect->getFirstPass() ;
        pass != NULL ;
	pass = m_pEffect->getNextPass()
      )
   {
      pass->enable() ;
      //m_oScene.draw() ;
      m_oDrawer.draw( m_oMeshScene.getMesh() ) ;
      pass->disable() ;
   }

   
}

//-------------------------------------------------------------------------

void CGLWindow::init( void )
{
   //restoreFromFile() ;
   glEnable( GL_TEXTURE_2D ) ;
   //glDepthRange( 0.1f, 100.0f ) ;
   m_oDrawer.setRenderingMode( X3DTK::MESH::REAL ) ;
}

//-------------------------------------------------------------------------




//-------------------------------------------------------------------------
// MODIFIEURS
//-------------------------------------------------------------------------

void CGLWindow::setSceneFile( const char * filename )
{
   //m_oScene.load( filename ) ;
   //setSceneBoundingBox( m_oScene.getBBoxMin().f_data(), m_oScene.getBBoxMax().f_data());
   m_oMeshScene.load( filename ) ;
   setSceneBoundingBox( m_oMeshScene.getBBoxMin().f_data(), m_oMeshScene.getBBoxMax().f_data() ) ;
}

//-------------------------------------------------------------------------

void CGLWindow::setEffect( CCGEffect * effect )
{
   m_pEffect = effect ;
}

//-------------------------------------------------------------------------

void CGLWindow::setLight(CGLLight * light, int num_light)
{
   lampe[num_light] = light;
}

//-------------------------------------------------------------------------
