//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : GLWindow.h
// Description : Classe contenant les informations d'une fenetre
//===========================================================================


#ifndef __GLWINDOW_H
#define __GLWINDOW_H

#include <X3DTK/simplex3dglscene.h>
#include <X3DTK/simplifiedmeshscene.h>
#include <X3DTK/MESH/facesdrawer.h>
#include <QGLViewer/qglviewer.h>
#include "CGEffect.h"
#include "./GLLight.h"

// a modifier
const int nb_light = 2;

//-------------------------------------------------------------------------
class CGLWindow : public QGLViewer
{
   
public :
      
   //-----------------------------------------------------------------
   // MODIFIEURS
   virtual void setSceneFile( const char * filename ) ;
   virtual void setLight(CGLLight * light, int num_light);

   virtual void setEffect( CCGEffect * effect ) ;
   //-----------------------------------------------------------------


protected :
      
   //-----------------------------------------------------------------
   // ACTIONS
   virtual void draw( void ) ;
   virtual void init( void ) ;
   //-----------------------------------------------------------------

   //-----------------------------------------------------------------
   // ACCESSEURS
   //virtual QString helpString( void ) const ;
   //-----------------------------------------------------------------


   CCGEffect * m_pEffect ;
   CGLLight  * lampe[nb_light];

   X3DTK::SimplifiedMeshScene m_oMeshScene ;
   X3DTK::MESH::FacesDrawer m_oDrawer ;
   //X3DTK::SimpleX3DGLScene m_oScene ;

} ;
//-------------------------------------------------------------------------

#endif //__GLWINDOW_H
